<?php defined('SYSPATH') OR die('No direct access allowed.');

class Model_cch extends Model
{
	
	public function getSOAP_accesspoint_wsdl()
	{
		$conf= (Kohana::DEVELOPMENT === Kohana::$environment) ? Kohana::$config->load('config')->accesspoint_wsdl : Kohana::$config->load('config')->accesspoint_wsdl_dev;
		
		$client = new SoapClient(Arr::get($conf, 'wsdl'),
        array( 
        "location" => Arr::get($conf, 'location'), 
        "uri"      => "urn:xmethods-delayed-quotes",
		"features" => SOAP_SINGLE_ELEMENT_ARRAYS,		
        "style"    => SOAP_RPC, 
        "use"      => SOAP_ENCODED 
           ));
		 return $client;
	}
	
	
	public function getSOAP_skud_wsdl()
	{
		$conf= (Kohana::DEVELOPMENT === Kohana::$environment) ? Kohana::$config->load('config')->skud_wsdl : Kohana::$config->load('config')->skud_wsdl_dev;
		$client = new SoapClient(Arr::get($conf, 'wsdl'), 
        array( 
        "location" => Arr::get($conf, 'location'), 
        "uri"      => "urn:xmethods-delayed-quotes", 
		"features" => SOAP_SINGLE_ELEMENT_ARRAYS,
        "style"    => SOAP_RPC, 
        "use"      => SOAP_ENCODED 
           ));
		return $client;
	
	}
	
	public function insertAction($data)// вставка мероприятия
	{
		if(isset($data))
		{
			$a1 =	strtotime(Arr::get($data, 'TimeStart'));
			$a2 =	strtotime(Arr::get($data, 'TimeEnd'));
			$data['TimeStart']=date("Y-m-d",$a1).'T'.date("H:i:s",$a1);
			$data['TimeEnd']=date("Y-m-d",$a2).'T'.date("H:i:s",$a2);
		}
		$ttt=array('Item'=>$data);
			
		$client=$this->getSOAP_skud_wsdl();
		$a=$client->ActionAdd($ttt)->ActionAddResult;
		return $a;
	}
	
	public function getDoorsList() // список точек прохода
	{
		$client=$this->getSOAP_accesspoint_wsdl();
		$a = $client->GetDoors()->GetDoorsResult->PlaceInfo ; // Список мероприятий
		$result=array();
		if(isset($a))
		{
			return $a;
		}
		return $result;
	}
	
	public function getDoorsList2() // список точек прохода
	{
		$client=$this->getSOAP_accesspoint_wsdl();
		$a = $client->GetDoors()->GetDoorsResult->PlaceInfo ; // Список мероприятий
		$result=array();
		if(isset($a))
		{ 
			foreach ($a as $key=>$value)
			{ 
				if(isset($value->Doors->DoorInfo))
					foreach ($value->Doors->DoorInfo as $a=>$b)
					{
						$result[$b->ID]['Name']=$b->Name;
						$result[$b->ID]['IsEnter']=$b->IsEnter;
						$result[$b->ID]['IsExit']=$b->IsExit;
						$result[$b->ID]['PlaceID']=$value->ID;
						$result[$b->ID]['PlaceName']=$value->Name;
					}
			}
			
		}
		return $result;
	}
	
	public function getKeyCount($actionID)// количество билетов, проданных на мероприятие
	{
				
			$client=$this->getSOAP_skud_wsdl();
			$a = $client->KeysGetByAction(array('ActionID'=>$actionID))->KeysGetByActionResult; // Список мероприятий
			//echo Debug::vars('10', $this->GetCurrentActionStats(101));exit;
			$keyCount=0;
			if($a->Success and isset($a->List)){
				if(isset($a->List->ActionTicketInfo )) $keyCount = count(($a->List->ActionTicketInfo ));
			} else {
				$keyCount=0;
			}
			return $keyCount;
		
	}

	
	public function getActionList()// список мероприятий
	{
			
		$client=$this->getSOAP_skud_wsdl();
		$list = $client->ActionGetList()->ActionGetListResult ; // Список мероприятий
		$result=null;
		$listPlace=array();
		if ($list->Success) {
			//получаю связь мероприятия - площадки.
			foreach ($list->List->ActionInfo as $key=>$value)
			{
				$listPlace[$value->ID]=$this->ActionPlaceGetList($value->ID);
			}
			
			
			//выбираю только номера площадок
			// теперь номера надо заменить именами площадок
			
			$res4=$this->listPlaceName();
				
			
			foreach ($listPlace as $a=>$b)
			{
					if(isset($b))
				{
					foreach($b as $ddt=>$vvt)
					{
						$res2[$a][]=$res4[$vvt->PlaceID] ;
						
					}

				}			
			}
			
		}
			$resulr=array();
		foreach ($list->List->ActionInfo as $key=>$value)
		{
			$result[$key]=$value->TimeStart;
		}
		asort($result);
		$action=array();
		foreach ($result as $key=>$value)
		{ 
			$action[]=$list->List->ActionInfo[$key];
		}
		return $result=array('action'=> $action, 'listPlaceName'=>$res2);
	} 
	
	
	
	public function listPlaceName()// выводит перечень площадок
	{
		$listPP=$this->getPlaceList()->List->PlaceInfo ;
			foreach ($listPP as $key=>$value)
			{
				$res4[$value->ID]=$value->Name;
			}
			return $res4;
	}
	
	public function ActionPlaceGetList($actionID)//перечень списка площадок, где проводится мероприятие
	{
		$client=$this->getSOAP_skud_wsdl();
		$a= $client->ActionPlaceGetList(array('ActionID'=>$actionID))->ActionPlaceGetListResult ;
		$result=array();

		if ($a->Success) {
			if (isset($a->List->ActionPlaceInfo)) $result=$a->List->ActionPlaceInfo;
			
		} else 	{
				$result='error '.$a->ErrorMessage ;
		}
			
		return $result;
		
	}
	
	
	public function getPlaceList()// список площадок
	{
		$client=$this->getSOAP_skud_wsdl();
		$a= $client->PlaceGetList()->PlaceGetListResult;
		$result=array();
		if ($a->Success) {
			return $a;
		}	
		return $result;
	}
	
	public function DoorsGetList($placeID)// список точек прохода для заданной площадки
	{
		$client=$this->getSOAP_skud_wsdl();
		$a= $client->DoorsGetList(array('PlaceID'=>$placeID))->DoorsGetListResult;
		$result=array();
		if ($a->Success) {
			if (isset($a->List->DoorInfo )){ 
				foreach ($a->List->DoorInfo   as $key=>$value){
						$result[$value->ID]['ID']= $value->ID;
						$result[$value->ID]['PlaceID']= $value->PlaceID ;
						$result[$value->ID]['Name']= $value->Name;
						$result[$value->ID]['IsEnter']= $value->IsEnter;
						$result[$value->ID]['IsExit']= $value->IsExit;
					}
				} else {
						$result[]['ID']= '';
						$result[]['PlaceID']= '';
						$result[]['Name']= '';
						$result[]['IsEnter']= '';
						$result[]['IsExit']= '';
				}
			} else {
				$result='error '.$a->ErrorMessage ;
		}	
		return $result;
	}
	
	public function getActionInfoByID($actionID)
	{
		$client=$this->getSOAP_skud_wsdl();
		$a=$client->ActionGetByID(array('ActionID'=>$actionID))->ActionGetByIDResult;
		$result=array();
		if ($a->Success) {
			$result= $a->List->ActionInfo;
		} else 	{
				$result='error '.$a->ErrorMessage ;
		}
		return array_shift($result);
		
	}
	
	
	
	public function getSOAPVersion()
	{
		//$client = new SoapClient(Kohana::$config->load('config')->skud_wsdl, array('features' => SOAP_SINGLE_ELEMENT_ARRAYS));
		$client=$this->getSOAP_skud_wsdl();
		$a= $client->GetVersion()->GetVersionResult;
		return $a;
	}
	
	public function GetCurrentActionStats($doorID, $actionID)// статистика по текущему мероприятию
	{
		$result=array();
		if(isset($doorID))
		{
			foreach ($doorID as $key=>$value)
			{
				//получаю данные о первой точке прохода
				$rt=$this->DoorsGetList($value->PlaceID);
					
				//получаю статистику по точке прохода
				$client_stat=$this->getSOAP_accesspoint_wsdl();
				$rt3 = $client_stat->GetCurrentActionStats(array('DoorID'=>Arr::get(array_shift($rt),'ID')));//
				if(isset($rt3->GetCurrentActionStatsResult ->ActionID) and $rt3->GetCurrentActionStatsResult ->ActionID == $actionID) $result[$value->PlaceID] = $rt3->GetCurrentActionStatsResult;
				
			}
		}
		return $result;
	}
	
	public function ActionPlaceGetListAdvanced ($actionID)// расширенный, добавляется количество прошедших на площадки, название площадки и список ТСД
	{
		// получил базовую информацию
		$result=$this->ActionPlaceGetList($actionID);
		
		// получил список площадок
		$client=$this->getSOAP_skud_wsdl();
		$lisrPlace= $client->PlaceGetList()->PlaceGetListResult->List->PlaceInfo;
		
		//формирую данные для каждой площадки
		foreach ($result as $key=>$value){
		
		//получаю список точек прохода по ID площадки.
			$rer=$this->DoorsGetList(Arr::get($value, 'PlaceID'));

			//Получаю статистику по первому же значению массива ID точек прохода
			$result[$key]['actionStat']= $this->GetCurrentActionStats(array_shift($rer));

			//получаю название площадки
			foreach ($lisrPlace as $a=>$b)
			{
				if($b->ID == Arr::get($value, 'PlaceID')) 
				{
					$result[$key]['placeName']['name']=$b->Name;
				}
			}
			$result[$key]['placeName']['doors']=$this->DoorsGetList(Arr::get($value, 'PlaceID'));
		}
	return $result;
	}
	
	public function listDoor()//выдает массив 'ID площадки'=>array(перечень точек прохода)
	{
		$client=$this->getSOAP_accesspoint_wsdl();
		$a = $client->GetDoors()->GetDoorsResult->PlaceInfo ; // Список мероприятий
		$result=array();
		foreach ($a as $key=>$value)
		{
			$result[$value->ID]=$a[$key];

		}		
		return $result;
	}
	
	public function KeysGetByAction ($actionID)
	{
			
		$client=$this->getSOAP_skud_wsdl();
		$a = $client->KeysGetByAction(array('ActionID'=>$actionID))->KeysGetByActionResult  ; // Список билетов
		return $a;
	}
	
	public function GetKeyProperties ($ticketvalue)
	{
		$client=$this->getSOAP_accesspoint_wsdl();
		$a = $client->GetKeyProperties(array('KeyValue'=>$ticketvalue, 'DoorID'=>101))->GetKeyPropertiesResult ; // Список билетов
		
		//echo Debug::vars('323', $a); exit;
		return $a;
	}
	
	public function stressTest ($count)
	{
		$client=$this->getSOAP_accesspoint_wsdl();
		for ($i=0 ; $i<$count; $i++)
		{
			$a = $client->RegisterPass(array(
				'DoorID'=>6662, 
				'KeyValue'=>'4640013550220', 
				'IsEnter'=>NULL)) ; // Список билетов
			
		}
	}
	
	public function KeysAdd ($key)
	{
		//echo Debug::vars('343', $a); exit;
		$client=$this->getSOAP_skud_wsdl();
		$a=$client->KeysAdd(array(
			'ActionID'=>1,
			'Comment'=>'Comment',
			'Items'=>array(
				'SoldTicketInfo'=>array(
					'KeyAttributes'=>array(12),
					'KeyData'=>'KeyData',
					'KeyValue'=>'112233')
					)
				));
				
		return $a;
	}	
	
	public function RegisterPass ($key)
	{
		if($key!==NULL or $key='') 
		{
		$client=$this->getSOAP_accesspoint_wsdl();
		$a=$client->RegisterPass(array('DoorID'=>6660, 'KeyValue'=>$key, 'IsEnter'=>True));
		} else {
			$a='Не указан номер билета для отметки о проходе.';
		}
		//echo Debug::vars('346', $a); exit;
		return $a;
	}	
	
	public function GetFailesPassList($key)
	{
		//echo Debug::vars('374', $key); exit;

		$client=$this->getSOAP_accesspoint_wsdl();
		$a=$client->GetFailesPassList(array('ActionID'=>$key, 'StartID'=>0))->GetFailesPassListResult;
		//$a=$client->GetFailesPassList(array('ActionID'=>1, 'StartID'=>0))->GetFailesPassListResult;
		return $a;
	}	
	
}
